import { FETCH_TASKS_FAILURE, FETCH_TASKS_REQUEST, FETCH_TASKS_SUCCESS, SET_NEW_TASKS_FOR_CELLS } from "../actionTypes/tasksTypes";

const initialState = {
    tasks: [],
    loading: false,
    error: null
};

const tasksReduсer = (state = initialState, action) => {
  switch(action.type) {
    case FETCH_TASKS_REQUEST:
        return {...state, loading: true};
    case FETCH_TASKS_SUCCESS:
        const newArr = action.tasks.map((task)=>{
            if (task.dateTimeStart && task.dateTimeDue) {
              const dateStart = task.dateTimeStart.split('T')[0]
              const timeStart = task.dateTimeStart.split('T')[1]
              const timeEnd = task.dateTimeDue.split('T')[1]
              const dayStart = parseInt(dateStart.split('-')[2])
              const dayOfWeekStartNumber = new Date(new Date().getFullYear(), new Date().getMonth(), dayStart).getDay()
              const dayOfWeekStartString = ["ВС","ПН","ВТ","СР","ЧТ","ПТ","СБ"][dayOfWeekStartNumber]
              const monthStartNumber =  parseInt(dateStart.split('-')[1])
              const yearStartNumber =  parseInt(dateStart.split('-')[0])
              const timeStartHour = parseInt(timeStart.split(':')[0])
              const timeEndHour = parseInt(timeEnd.split(':')[0])
              return {...task, 
                startDay: dayStart, 
                startDayOfWeek: dayOfWeekStartString, 
                startHour: timeStartHour, 
                startMonth: monthStartNumber,
                startYear: yearStartNumber,
                endHour: timeEndHour,
              } 
            } 
          })
        return {...state, loading: false, tasks: newArr};
    case FETCH_TASKS_FAILURE:
        return {...state, loading: false, error: action.error};
    case SET_NEW_TASKS_FOR_CELLS: 
        return {...state, tasks: action.tasks}
    default: 
        return state;
}
};

export default tasksReduсer;